import 'package:flutter/material.dart';
import 'package:flutter_test/flutter_test.dart';
import 'package:reactive_forms/reactive_forms.dart';

void main() {
  group('ReactiveForm Tests', () {
    testWidgets(
      'ReactiveForm with null form group throws assertion error',
      (WidgetTester tester) async {
        // Given: a ReactiveForm with null group
        final reactiveForm = () => ReactiveForm(
              formGroup: null,
              child: Container(),
            );

        // Expect assertion error
        expect(reactiveForm, throwsAssertionError);
      },
    );

    testWidgets(
      'ReactiveForm with null child throws assertion error',
      (WidgetTester tester) async {
        // Given: a ReactiveForm with null child
        final reactiveForm = () => ReactiveForm(
              formGroup: FormGroup({}),
              child: null,
            );

        // Expect assertion error
        expect(reactiveForm, throwsAssertionError);
      },
    );
  });
}
